#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <thread.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sched.h>


   int mat_a[100][100];
   int mat_b[100][100];
   int rslt[100][100];

class args {
public:
   int start;
   int end;
   int dim;

   args(int start, int end, int dim);
};//args


args::args(int strt, int nd, int dm) {
   start = strt;
   end = nd;
   dim = dm;
}//constructor


void* do_section(void* my_args);

int main(int argc, const char* argv[]) {
   int do_threads = 0;
   int do_display = 0;

   int dim = 100;
   int i, j, k = 0, sum, q = 77777;
   thread_t child1, child2, child3;

   if (argc == 1) {
      printf("USAGE:  a.out <DT> <DM>\n");
   }//if

   for (i = 1; i<argc; i++) {
      if (strcasecmp(argv[i], "DT") == 0)
	 do_threads = 1;
      else if (strcasecmp(argv[i], "DD") == 0)
	 do_display = 1;
   }//for
  
   for (i = 0; i<dim; i++) {
      for (j = 0; j<dim; j++) {
	 mat_a[i][j] = ++k;
	 mat_b[i][j] = --q;
         rslt[i][j] = 0;
      }//for
   }//for

     struct timeval* tp = new timeval;
     struct timeval* tp_after = new timeval;
     gettimeofday(tp, NULL);

//     printf("Entering for loop at: %d, %d.\n", tp->tv_sec, tp->tv_usec);

   if (do_threads) {
     printf("Doing threaded version.\n");

     thr_setconcurrency(4);

     thr_create(NULL, 0, do_section, new args(0, dim/3, dim), 0, &child1);
     thr_create(NULL, 0, do_section, new args(dim/3, 2 * dim/3, dim), 0,   
	      &child2);
     thr_create(NULL, 0, do_section, new args(2*dim/3, dim, dim), 0, 
	      &child3);

     thr_join(child1, NULL, NULL);
     thr_join(child2, NULL, NULL);
     thr_join(child3, NULL, NULL);
   }//if
   else {
     printf("Doing single threaded model.\n");
     do_section((void*)(new args(0, dim, dim)));
   }//else

   gettimeofday(tp_after, NULL);

//   printf("Exiting for loop at: %d, %d.\n", tp_after->tv_sec, 
//	tp_after->tv_usec);   

   int secs = tp_after->tv_sec - tp->tv_sec;
   int msecs = tp_after->tv_usec - tp->tv_usec;
   if (msecs < 0) {
      msecs += 1000000;
      secs--;
   }//if

   printf("TOTAL ELAPSED TIME:  %i seconds and %i miliseconds.\n", secs, 
		msecs);
   if (do_display) {
      for (i = 0; i<dim; i++) {
         printf("<< ");
         for (j = 0; j<dim; j++) { 
	    printf("%i ", rslt[i][j]);
         }//for
         printf(" >>\n");
      }//for
   }//if

   return 0;
}//main


void* do_section(void* my_args_void) {
   args* my_args = (args*)(my_args_void);
   int begin = my_args->start;
   int end = my_args->end;
   int dim = my_args->dim;
   int sum, i, j, k;

   printf("In do section: %i, %i, %i.\n", begin, end, dim);

   for (i = begin; i<end; i++) {
      for (j = 0; j<dim; j++) {
	 sum = 0;
	 for (k = 0; k<dim; k++) {
	    sum += mat_a[i][k] * mat_b[k][j];
	 }//for
	 rslt[i][j] = sum;
      }//for
   }//for
   return NULL;
}//do_section
